[CCode (cprefix = "E", lower_case_cprefix = "e_")]
namespace E {
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_book_backend_get_type ()")]
	public class BookBackend : E.Backend {
		[CCode (has_construct_function = false)]
		private BookBackend ();
		public unowned string get_cache_dir ();
		public string dup_cache_dir ();
		public void set_cache_dir (string cache_dir);
		public E.DataBook ref_data_book ();
		public void set_data_book (E.DataBook data_book);
		public E.SourceRegistry get_registry ();
		public bool get_writable ();
		public void set_writable (bool writable);
		public bool is_opened ();
		public bool is_readonly ();
		public virtual string get_backend_property (string prop_name);
		public virtual bool open_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool open (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool refresh_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool refresh (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool create_contacts_sync (string[] vcards, GLib.Queue<E.Contact> out_contacts, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool create_contacts (string[] vcards, GLib.Queue<E.Contact> out_contacts, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool modify_contacts_sync (string[] vcards, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool modify_contacts (string[] vcards, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool remove_contacts_sync (string[] uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool remove_contacts (string[] uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual E.Contact get_contact_sync (string uid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async E.Contact get_contact (string uid, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool get_contact_list_sync (string query, GLib.Queue<E.Contact> out_contacts, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool get_contact_list (string query, GLib.Queue<E.Contact> out_contacts, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual bool get_contact_list_uids_sync (string query, GLib.Queue<string> out_uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool get_contact_list_uids (string query, GLib.Queue<string> out_uids, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public virtual void start_view (E.DataBookView view);
		public virtual void stop_view (E.DataBookView view);
		public void add_view (E.DataBookView view);
		public void remove_view (E.DataBookView view);
		public GLib.List<E.DataBookView> list_views ();
		public void notify_update (E.Contact contact);
		public void notify_remove (string id);
		public void notify_complete ();
		public void notify_error (string message);
		public void notify_property_changed (string prop_name, string prop_value);
		public void sync ();
		public E.DataBookDirect get_direct_book ();
		public void configure_direct (string config);
		[NoAccessorMethod]
		public string cache_dir { get; set; }
		[NoAccessorMethod]
		public E.SourceRegistry registry { get; construct set; }
		[NoAccessorMethod]
		public bool writable { get; set; }
		public virtual signal void shutdown (string sender);
		public signal void closed ();
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_book_backend_cache_get_type ()")]
	public class BookBackendCache : E.FileCache {
		[CCode (has_construct_function = false)]
		public BookBackendCache (string filename);
		public E.Contact get_contact (string uid);
		public bool add_contact (E.Contact contact);
		public bool remove_contact (string uid);
		public bool check_contact (string uid);
		public GLib.List<E.Contact> get_contacts (string query);
		public void set_populated ();
		public bool is_populated ();
		public void set_time (string t);
		public string get_time ();
		public GLib.GenericArray<string> search (string query);
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_book_backend_factory_get_type ()")]
	public abstract class BookBackendFactory : E.BackendFactory {
		[CCode (has_construct_function = false)]
		private BookBackendFactory ();
		public class string factory_name;
		public class GLib.Type backend_type;
	}
	namespace BookBackendProperty {
		[CCode (cheader_filename = "libedata-book/libedata-book.h", cname = "BOOK_BACKEND_PROPERTY_REQUIRED_FIELDS")]
		public const string REQUIRED_FIELDS;
		[CCode (cheader_filename = "libedata-book/libedata-book.h", cname = "BOOK_BACKEND_PROPERTY_SUPPORTED_FIELDS")]
		public const string SUPPORTED_FIELDS;
		[CCode (cheader_filename = "libedata-book/libedata-book.h", cname = "BOOK_BACKEND_PROPERTY_REVISION")]
		public const string REVISION;
		[CCode (cheader_filename = "libedata-book/libedata-book.h", cname = "CLIENT_BACKEND_PROPERTY_CAPABILITIES")]
		public const string CAPABILITIES;
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_book_backend_sexp_get_type ()")]
	public class BookBackendSExp : GLib.Object {
		[CCode (has_construct_function = false)]
		public BookBackendSExp (string text);
		public unowned string text ();
		public bool match_vcard (string vcard);
		public bool match_contact (E.Contact contact);
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_data_book_get_type ()")]
	public class DataBook : GLib.Object {
		[CCode (has_construct_function = false)]
		public DataBook (E.BookBackend backend, GLib.DBusConnection connection, string object_path) throws GLib.Error;
		public GLib.Error create_error (E.DataBookStatus status, string custom_msg);
		public GLib.Error create_error_fmt (E.DataBookStatus status, string custom_msg_fmt, ...);
		public unowned string status_to_string (E.DataBookStatus status);
		public E.BookBackend ref_backend ();
		public GLib.DBusConnection get_connection ();
		public unowned string get_object_path ();
		public void respond_open (uint32 opid, GLib.Error error);
		public void respond_refresh (uint32 opid, GLib.Error error);
		public void respond_create_contacts (uint32 opid, GLib.Error error, GLib.SList<E.Contact> contacts);
		public void respond_remove_contacts (uint32 opid, GLib.Error error, GLib.SList<string> ids);
		public void respond_modify_contacts (uint32 opid, GLib.Error error, GLib.SList<E.Contact> contacts);
		public void respond_get_contact (uint32 opid, GLib.Error error, GLib.SList<string> vcard);
		public void respond_get_contact_list (uint32 opid, GLib.Error error, GLib.SList<string> cards);
		public void respond_get_contact_list_uids (uint32 opid, GLib.Error error, GLib.SList<string> uids);
		public void report_error (string message);
		public void report_backend_property_changed (string prop_name, string prop_value);
		public static string string_slist_to_comma_string (GLib.SList<string> strings);
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_data_book_direct_get_type ()")]
	public class DataBookDirect : GLib.Object {
		[CCode (has_construct_function = false)]
		public DataBookDirect (string backend_path, string backend_factory_name, string config);
		public bool register_gdbus_object (GLib.DBusConnection connection, string object_path) throws GLib.Error;
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_data_book_factory_get_type ()")]
	public class DataBookFactory : E.DataFactory, E.Extensible, GLib.Initable {
		[CCode (has_construct_function = false)]
		public DataBookFactory (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public E.SourceRegistry get_registry ();
	}
	[CCode (cheader_filename = "libedata-book/libedata-book.h", type_id = "e_data_book_view_get_type ()")]
	public class DataBookView : GLib.Object, GLib.Initable {
		[CCode (has_construct_function = false)]
		public DataBookView (E.BookBackend backend, E.BookBackendSExp sexp, GLib.DBusConnection connection, string object_path) throws GLib.Error;
		public E.BookBackend get_backend ();
		public GLib.DBusConnection get_connection ();
		public string get_object_path ();
		public unowned E.BookBackendSExp get_sexp ();
		public E.BookClientViewFlags get_flags ();
		public void notify_update (E.Contact contact);
		public void notify_update_vcard (string id, string vcard);
		public void notify_update_prefiltered_vcard (string id, string vcard);
		public void notify_remove (string id);
		public void notify_complete (GLib.Error error);
		public void notify_progress (uint percent, string message);
		public GLib.HashTable<string, string> get_fields_of_interest ();
	}
}